//
//  SelfieRouter.swift
//  FADModulePhoto
//
//  Created by Juan Carlos Pérez on 1/25/19.
//  Copyright (c) 2019 Juan Carlos Pérez. All rights reserved.
//
//  This file was generated by the Clean Swift Xcode Templates so
//  you can apply clean architecture to your iOS and Mac projects,
//  see http://clean-swift.com
//

import UIKit

@objc protocol SelfieRoutingLogic
{
  func routeToShowPreview(segue: UIStoryboardSegue?)
}

protocol SelfieDataPassing
{
  var dataStore: SelfieDataStore? { get }
}

class SelfieRouter: NSObject, SelfieRoutingLogic, SelfieDataPassing
{
    
  weak var viewController: SelfieViewController?
  var dataStore: SelfieDataStore?
    
    
    func routeToShowPreview(segue: UIStoryboardSegue?) {
        if let segue = segue {
            let destinationVC = segue.destination as! SelfiePreviewViewController
            var destinationDS = destinationVC.router!.dataStore!
            passDataToShowSelfie(source: dataStore!, destination: &destinationDS)
        } else {
            let destinationVC = viewController?.storyboard?.instantiateViewController(withIdentifier: "selfiePreviewViewId") as! SelfiePreviewViewController
            var destinationDS = destinationVC.router!.dataStore!
            passDataToShowSelfie(source: dataStore!, destination: &destinationDS)
            navigateToShowSelfie(source: viewController!, destination: destinationVC)
        }
    }
    
    
    // MARK: Navigation
    func navigateToShowSelfie(source: SelfieViewController, destination: SelfiePreviewViewController)
    {
        source.show(destination, sender: nil)
    }
    
    
    // MARK: Passing data
    func passDataToShowSelfie(source: SelfieDataStore, destination: inout SelfiePreviewDataStore)
    {
        let imgSelfie = viewController?.imgPhoto
        destination.imgSelfie = imgSelfie
    }

}
